------------------------------------------------------------------------
-- Addon Core
------------------------------------------------------------------------

local ADDON_NAME, NPG = ...

local SecureHandlerSetFrameRef = _G.SecureHandlerSetFrameRef
local SecureHandlerExecute = _G.SecureHandlerExecute
local pairs = _G.pairs
local type = _G.type
local print = _G.print

NPG._addon = {}

function NPG._addon.SetFrameRef(frame, name, refFrame)
   SecureHandlerSetFrameRef(frame, name, refFrame)
   SecureHandlerExecute(frame, name .. " = self:GetFrameRef('"..name.."')")
end

function NPG._addon.tContains(table, value)
   for i = 1, #table do
      if table[i] == value then
         return i
      end
   end
   return nil
end

function NPG._addon.RegisterEvents(eventTable, frame)
   frame = frame or eventTable
   
   frame:UnregisterAllEvents()
   for eventName in pairs(eventTable) do
      if type(eventName) == "string" then frame:RegisterEvent(eventName) end
   end
   
   frame:SetScript("OnEvent", function(self, event, ...) 
      eventTable[event](eventTable, ...)
   end)
end


local COLOR_FORMAT = "\124cff66ee99<%s>\124r"
function NPG._addon.print(...)
   print(COLOR_FORMAT:format(ADDON_NAME), ...)
end